#include "C:\PIC\vs\vs.h"

#define MASK	0b00011111

void diag() {
   int i;
   int c = 1;

   for (i = 0; i < 7; i++) {
      output_a(c ^ 0xff);
      c = c << 1;
      if ( i == 4) {
         c <<= 1;
         i++;
      }
      delay_ms(100);
   }

   c = 0b01000000;
   for (i = 0; i < 7; i++) {
      output_a(c ^ 0xff);
      c >>= 1;
      if ( i == 0) {
         c >>= 1;
         i++;
      }
      delay_ms(100);
   }
}

int get_key()
{
   unsigned int key1, key2;
   key1 = input_b() & MASK;
   if (key1 < MASK) {
      delay_ms(100);
      key2 = input_b() & MASK;
      if (key1 != key2) return 0;
   } else {
      key_pressed = 0;
      return 0;
   }
   if (!bit_test(key1,0))
      if (key_pressed == 1)
         return 0;
      else
         return 1;
   else if (!bit_test(key1,1))
      if (key_pressed == 2)
         return 0;
      else
         return 2;
   else if (!bit_test(key1,2))
      if (key_pressed == 3)
         return 0;
      else
         return 3;
   else if (!bit_test(key1,3))
      if (key_pressed == 4)
         return 0;
      else
         return 4;
   else if (key_pressed == 5)
      return 0;
   else
      return 5;
}

void set_channel()
{
   unsigned int d,led;
   d= av_selected - 1;
   if (comp_selected == 1) d|= 0b00000100;
   d= d << 5;
   d |= 0b00011111;
   output_b(d);

   led = 1;
   // led = led << (av_selected - 1);
   switch (av_selected) {
     case 1:
       led = 0b11111110;
       break;
     case 2:
       led = 0b11111101;
       break;
     case 3:
       led = 0b11111011;
       break;
     case 4:
       led = 0b11110111;
       break;
   }
   if (comp_selected == 2) led &= 0b10111111;
   else led &= 0b11101111;
   // led ^= 0xff;
   output_a(led);
}

void save_conf()
{
   write_EEPROM(0, av_selected);
   write_EEPROM(1, comp_selected);
}

void read_conf()
{
   av_selected = read_EEPROM(0);
   if (av_selected > 4 || av_selected < 1) {
      av_selected = 1;
      write_EEPROM(0, av_selected);
   }
   comp_selected = read_EEPROM(1);
   if (comp_selected > 2 || comp_selected < 1) {
      comp_selected = 1;
      write_EEPROM(1, comp_selected);
   }
}

void main() {
   int key_no;

   port_b_pullups(TRUE);
   setup_counters(RTCC_INTERNAL,RTCC_DIV_2);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_vref(FALSE);
   setup_comparator(FALSE);

   set_tris_a(0);
   set_tris_b(0b00011111);

   diag();

   read_conf();

   set_channel();

   old_key = 0;
   key_pressed = 0;

   while(1) {
      if ((key_no = get_key()) > 0) {
         key_pressed = key_no;
         if ((key_no < 5) && (old_key == key_no)) continue;
         old_key = key_no;
         if (key_no == 5) {
            if (comp_selected == 2) comp_selected = 1;
            else  comp_selected = 2;
            set_channel();
            save_conf();
         } else {
            if (key_no != av_selected) {
               av_selected = key_no;
               set_channel();
               save_conf();
            }
         }
      }
   }
}


#ROM 0x2100 = {3,2}
